package ru.landgrafhomyak.serdha.api.v0.queries

import ru.landgrafhomyak.serdha.api.v0.misc.Column
import ru.landgrafhomyak.serdha.api.v0.misc.DatabaseType
import ru.landgrafhomyak.serdha.api.v0.misc.DatabaseTypesProvider
import ru.landgrafhomyak.serdha.api.v0.misc.QueryParam
import ru.landgrafhomyak.serdha.api.v0.misc.SelectedColumn
import ru.landgrafhomyak.serdha.api.v0.misc.SelectedTable
import ru.landgrafhomyak.serdha.api.v0.table.Table

@Suppress("RemoveRedundantQualifierName")
public interface DeleteQuery<QueryUserExtension : Any> {
	public val userExtension: QueryUserExtension

	public interface Creator<QueryUserExtension : Any, TargetTableUserExtension : Any, SelectorTableUserExtension : Any> {
		public fun createDelete(table: Table<TargetTableUserExtension, *>, creator: DeleteQuery.Creator.Scope<QueryUserExtension, TargetTableUserExtension, SelectorTableUserExtension>): QueryUserExtension

		public interface Scope<QueryUserExtension : Any, TargetTableUserExtension : Any, SelectorTableUserExtension : Any> {
			public val selector: SelectedTable.WithParamsRedirect<SelectorTableUserExtension, QueryUserExtension>

			public var selectorColumn: SelectedColumn<*, DatabaseType.ROW_ID<TargetTableUserExtension>, SelectorTableUserExtension, QueryUserExtension>

			public val types: DatabaseTypesProvider

			public fun <RT, DT : DatabaseType<RT>> param(name: String, type: DT): QueryParam<RT, DT, QueryUserExtension>
		}
	}

	public interface WithReturning<QueryUserExtension : Any> : DeleteQuery<QueryUserExtension>, _Selectable<QueryUserExtension> {
		public interface Creator<QueryUserExtension : Any, TargetTableUserExtension : Any, SelectorTableUserExtension : Any> {
			public fun createDelete(table: Table<TargetTableUserExtension, *>, creator: DeleteQuery.WithReturning.Creator.Scope<QueryUserExtension, TargetTableUserExtension, SelectorTableUserExtension>): QueryUserExtension

			public interface Scope<QueryUserExtension : Any, TargetTableUserExtension : Any, SelectorTableUserExtension : Any> : DeleteQuery.Creator.Scope<QueryUserExtension, TargetTableUserExtension, SelectorTableUserExtension> {
				public val removedValues: SelectedTable<TargetTableUserExtension, QueryUserExtension>

				public fun <RT, DT : DatabaseType<RT>> returnColumn(c: SelectedColumn<RT, DT, *, QueryUserExtension>): Column<RT, DT, QueryUserExtension>
			}
		}
	}
}