package ru.landgrafhomyak.serdha.api.v0.queries

import ru.landgrafhomyak.serdha.api.v0.misc.Column
import ru.landgrafhomyak.serdha.api.v0.table.Table
import ru.landgrafhomyak.serdha.api.v0.misc.DatabaseType
import ru.landgrafhomyak.serdha.api.v0.misc.QueryParam
import ru.landgrafhomyak.serdha.api.v0.misc.SelectedColumn
import ru.landgrafhomyak.serdha.api.v0.misc.SelectedTable

@Suppress("RemoveRedundantQualifierName")
public interface UpdateQuery<QueryUserExtension : Any> {
	public val userExtension: QueryUserExtension

	public interface Creator<QueryUserWrapper : Any, TargetTableUserExtension : Any, SelectorTableUserExtension : Any> {
		public fun createUpdate(table: Table<TargetTableUserExtension, *>, creator: Scope<QueryUserWrapper, TargetTableUserExtension, SelectorTableUserExtension>): QueryUserWrapper

		public interface Scope<QueryUserExtension : Any, TargetTableUserExtension : Any, SelectorTableUserExtension : Any> {
			public val oldValues: SelectedTable<TargetTableUserExtension, QueryUserExtension>

			public val selector: SelectedTable.WithParamsRedirect<SelectorTableUserExtension, QueryUserExtension>

			public var selectorColumn: SelectedColumn<*, DatabaseType.ROW_ID<TargetTableUserExtension>, SelectorTableUserExtension, QueryUserExtension>

			public fun <RuntimeType, DT : DatabaseType<RuntimeType>> updateColumn(c: Column<RuntimeType, DT, TargetTableUserExtension>, e: SelectedColumn<RuntimeType, DT, SelectorTableUserExtension, QueryUserExtension>)

			public fun <RT, DT : DatabaseType<RT>> param(name: String, type: DT): QueryParam<RT, DT, QueryUserExtension>
		}
	}

	public interface WithReturning<QueryUserExtension : Any> : UpdateQuery<QueryUserExtension>, _Selectable<QueryUserExtension> {
		public interface Creator<QueryUserExtension : Any, TargetTableUserExtension : Any, SelectorTableUserExtension : Any> {
			public fun createDelete(table: Table<TargetTableUserExtension, *>, creator: UpdateQuery.WithReturning.Creator.Scope<QueryUserExtension, TargetTableUserExtension, SelectorTableUserExtension>): QueryUserExtension

			public interface Scope<QueryUserExtension : Any, TargetTableUserExtension : Any, SelectorTableUserExtension : Any> : UpdateQuery.Creator.Scope<QueryUserExtension, TargetTableUserExtension, SelectorTableUserExtension> {
				public fun <RT, DT : DatabaseType<RT>> returnColumn(c: SelectedColumn<RT, DT, *, QueryUserExtension>): Column<RT, DT, QueryUserExtension>
			}
		}
	}
}